import { formatDuration } from "date-fns";
// https://github.com/date-fns/date-fns/issues/2134#issuecomment-788212525

const formatDistanceLocale = {
  xSeconds: "{{count}}s",
  xMinutes: "{{count}}m",
  xHours: "{{count}}h",
};
const shortEnLocale = {
  formatDistance: (
    /** @type {string | number} */ token,
    /** @type {any} */ count
  ) => formatDistanceLocale[token].replace("{{count}}", count),
};

export default (/** @type {Duration} */ duration) => {
  return formatDuration(duration, {
    format: ["hours", "minutes", "seconds"],
    locale: shortEnLocale,
  });
};
