// /**
//  * @template Type
//  * @typedef {{
//   [Property in keyof Type]: Type[Property] extends import("svelte/store").Readable ? Type[Property]['subscribe']['arguments'] : Type[Property];
// }} Resolved */

import * as Y from "yjs";

/**
 * @typedef {{
  [key: string]: import("svelte/store").Readable
}} DataStores */
/**
 * @template {DataStores} T
 * @typedef {{
  [Property in keyof T]: Parameters<Parameters<T[Property]['subscribe']>[0]>[0]
}} Data */

import { derived } from "svelte/store";

/**
 * @template {DataStores} T
 * @param {T} thing
 * @returns {import('svelte/store').Readable<Data<T>>}
 */
export function deriveObj(thing) {
  return derived(Object.values(thing), (values) => {
    const keys = Object.keys(thing);
    // prettier-ignore
    return /** @type {Data<T>} */(Object.fromEntries(
      values.map(($v, i) => [keys[i], $v])
    ))
  });
}
